classification
Title: pickle: Possibly misplaced test
Type: behavior Stage: resolved
Components: Tests Versions: Python 3.2, Python 3.3
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: alexandre.vassalotti, mstefanro, pitrou, python-dev, r.david.murray
Priority: normal Keywords: patch

Created on 2012-06-15 16:37 by mstefanro, last changed 2012-06-26 21:08 by pitrou. This issue is now closed.

Files
File name Uploaded Description Edit
pickletester.py.patch mstefanro, 2012-06-15 16:37 Moves the test to the right place and adds IndexError to the list of exceptions that can be raised
Messages (4)
msg162919 - (view) Author: Stefan Mihaila (mstefanro) * Date: 2012-06-15 16:37
After issue7455 was fixed, a test was created to reflect the fix (Lib/test/pickletester.py @ AbstractPickleModuleTests.test_bad_input). The test makes sure that an UnpicklingError is raised whenever pickled data attempts to pop on an empty stack.
Although tests on AbstractPickleModuleTests normally only run on the C implementation of pickle (on which UnpicklingError is thrown), they may also run on the Python implementation if the C implementation of pickle is not available (which throws IndexError). I'm not sure if it's still reasonable to assume that it's possible for the C implementation of pickle not to exist (the python module does), as I've discovered this by forcefully disabling the C implementation.

>>> pickle.Unpickler(io.BytesIO(b'0')).load()
_pickle.UnpicklingError: unpickling stack underflow

>>> pickle._Unpickler(io.BytesIO(b'0')).load()
IndexError: list assignment index out of range

The current fix involves adding IndexError to the list of exceptions that may be raised and moving the testcase to AbstractPickleTests (where the tests are ran against both the C and Python impl).

As I'm working on improving pickle in protocol v4, it might be worth considering adding more consistency to the exceptions that are being raised by the Python unpickler.
msg162921 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2012-06-15 17:10
It would be best to have the pickle tests always run against both the C and python code.  We do this for other modules that have C versions of some or all of the Python code.  And yes, making the two consistent is also good.  Since pickle is generally not used without the C code, making the Python consistent with the C would seem to be a low-impact change.
msg164107 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2012-06-26 21:06
New changeset 5881a58c5425 by Antoine Pitrou in branch '3.2':
Issue #15079: make a test applicable to both C and Python versions of the pickle module.
http://hg.python.org/cpython/rev/5881a58c5425

New changeset b66e82c9f852 by Antoine Pitrou in branch 'default':
Issue #15079: make a test applicable to both C and Python versions of the pickle module.
http://hg.python.org/cpython/rev/b66e82c9f852
msg164108 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2012-06-26 21:08
Committed. Congratulations on your first patch!
History
Date User Action Args
2012-06-26 21:08:04pitrousetstatus: open -> closed
versions: + Python 3.2
messages: + msg164108

resolution: fixed
stage: resolved
2012-06-26 21:06:28python-devsetnosy: + python-dev
messages: + msg164107
2012-06-23 04:47:54terry.reedysetnosy: + pitrou
2012-06-15 19:23:45collinwintersetnosy: - collinwinter
2012-06-15 17:10:28r.david.murraysetnosy: + r.david.murray

messages: + msg162921
versions: + Python 3.3, - Python 3.4
2012-06-15 16:37:50mstefanrocreate